unit UDVListe;

interface

uses sysutils, classes, dialogs,stdctrls, UListNode;

type TdvListe = class(TObject)
     private
       Count,Index:integer;
       Dummy, ActualNode:TListNode;
     public
       constructor Create; virtual;
       destructor Destroy; override;
       procedure insert (Element: TObject); virtual;
       procedure Add (Element: TObject); virtual;
       procedure Delete; virtual;
       procedure DeleteAll; virtual;
       procedure First; virtual;
       procedure Last; virtual;
       procedure Next; virtual;
       procedure Previous; virtual;
         function isfirst: boolean;virtual;
         function islast: boolean; virtual;
         function GetElement: TObject; virtual;
         function GetCount: integer; virtual; (*keine Listenmethode!!*)
         function GetIndex:integer;virtual;   (*keine Listenmethode!!*)
         function isempty: Boolean; virtual;
     end;

implementation

constructor TdvListe.Create;
begin
 (******************************     AUFGABE     ****************************)
    count := 0;
    Index := 0;
 end;

destructor TdvListe.Destroy;
 begin
   while not isempty do begin
     delete;
   end;
   Dummy.destroy;
   dummy:=nil;
 end;

procedure TdvListe.Add (Element: TObject);
var
   newNode:TListnode;
 begin
   newNode:=TListnode.Create(Element);
   (* Zuerst wird der neue Knoten vor dem Dummy eingekettet *)
   (******************************     AUFGABE     ****************************)


   (*Nach dem Einketten wird das Neue Element zum aktuellen Element *)
    ActualNode := newNode;
   Inc(count);
   Index := 1;
 end;

procedure TdvListe.Insert (Element: TObject);
var
   newNode:TListnode;
 begin
   newNode:=TListnode.Create(Element);
   (* Zuerst wird der neue Knoten vor dem aktuellen Knoten eingekettet *)
   (******************************     AUFGABE     ***************************)
   (* Hilfe:  Prsentation                                                   *)


   (* Dann wird das neue Element zum aktuellen Knoten *)
      ActualNode := newNode;
   Inc(count); Inc(Index);
 end;

 procedure TdvListe.Delete;
 var
   temP:TListNode;
 begin
   if count=0 then showmessage('Delete bei leerer Liste')
   else begin
      if Index=0 then showmessage('Delete auf Dummy')
      else begin
         ActualNode.ReadPred.WriteSucc(ActualNode.ReadSucc);
         ActualNode.ReadSucc.WritePred(ActualNode.ReadPred);
         temp:=ActualNode;
         ActualNode:=ActualNode.ReadSucc;
         temp.destroy;
         Dec(count);
         if Index>count then begin
            Index:=count;
            ActualNode:=ActualNode.ReadPred    (* <<--- !!! WICHTIG !!!   *)
            (* sonst zeigt ActualNode auf den Dummy , was ein FEHLER wre *)
         end;
      end
   end
end;

 procedure TdvListe.deleteall;
 begin
   while not isempty do
     delete;
 end;

procedure TdvListe.First;
begin
   (******************************     AUFGABE     ***************************)
   Index := 1
end;

procedure TdvListe.Last;
begin
   (******************************     AUFGABE     ***************************)
   Index := count
end;

procedure TdvListe.Next;
begin
   (******************************     AUFGABE     ***************************)
   inc(index)
end;

procedure TdvListe.Previous;
begin
   (******************************     AUFGABE     ***************************)
   dec(index)
end;

function  TdvListe.GetElement: TObject;
begin
   if count=0 then
        showmessage('Get bei leerer Liste')
   else result := ActualNode.readValue
 end;

function TdvListe.GetIndex: Integer;
   begin
       GetIndex := Index
   end ;

function TdvListe.isempty: Boolean;
  begin
      isempty := (count=0)
  end;

function TdvListe.isfirst: boolean;
  begin
     isfirst:= (Index=1)
  end;

function TdvListe.islast: boolean;
  begin
     islast:= (Index=count)
  end;

function TdvListe.Getcount: integer;
  begin
     GetCount:= count
  end;

end.
