unit ULinList;

interface

uses sysutils, classes, dialogs,stdctrls, ULinListNode, USortElement;

type TLinList = class(TObject)
     private
       Count,Index:integer;  {Hilfsvariable, sind zur Verwaltung nicht ntig }
       Dummy, PredNode,ActualNode:TLinListNode;
     public
       constructor Create; virtual;
       destructor Destroy; override;
       procedure insert (Element: TObject); virtual;
       procedure add (Element: TObject); virtual;
       procedure Delete; virtual;
       procedure First; virtual;
       procedure Next; virtual;
         function islast: boolean; virtual;
         function GetElement: TObject; virtual;
         function GetCount: integer; virtual; (*keine Listenmethode!!*)
         function GetIndex:integer;virtual;   (*keine Listenmethode!!*)
         function isempty: Boolean; virtual;
     end;

implementation

constructor TLinList.Create;
begin
    dummy:=TLinListNode.Create(nil);
    PredNode:=Dummy;
    actualNode := PredNode.ReadSucc;
    Index := 0;
    count := 0
end;

destructor TLinList.Destroy;
 begin
   first;
   while not isempty do begin
     delete;
   end;
   Dummy.destroy;
   dummy:=nil;
 end;

procedure TLinList.Add (Element: TObject);
var
   newNode:TLinListNode;
begin
   newNode:=TLinListNode.Create(Element);
   if isempty then begin
      PredNode.WriteSucc(newNode);
      actualNode := newNode;
   end
   else begin
      repeat next until islast;
      actualnode.WriteSucc(newNode);
      prednode := actualNode;
      actualNode := newNode;
   end;
   inc(count);
   index := count
end;

procedure TLinList.Insert (Element: TObject);
var
   newNode:TLinListNode;
 begin
   newNode:=TLinListNode.Create(Element);
   if isempty then
      add(Element)
   else begin
   (* Zuerst wird der neue Knoten vor dem Dummy eingekettet *)
       newNode.WriteSucc(actualNode);
       PredNode.WriteSucc(newNode);
       actualNode := newNode;
       Inc(count);
    end (* of else *)
 end;

procedure TLinList.Delete;
 begin
   if isempty then showmessage('Delete bei leerer Liste')
   else begin
      PredNode.writeSucc(actualNode.ReadSucc);
      actualNode := PredNode.ReadSucc;
      Dec(count);
      if actualnode=nil then begin
         predNode := dummy;
         actualNode := PredNode.ReadSucc;
         index := 0;
         if not isempty then begin
            index := 1;
            while (actualNode.ReadSucc <> nil) do begin
               predNode := ActualNode;
               ActualNode := PredNode.ReadSucc;
               inc(index)
            end;
         end; (* of if *)
         count := index
      end (* of if *)
    end (* of else *)
end;

procedure TLinList.First;
begin
   if not isempty then begin
      PredNode   := Dummy ;
      actualNode := PredNode.ReadSucc;
      Index := 1
   end
end;

procedure TLinList.Next;
 begin
   if not isempty and not islast then begin
      PredNode := ActualNode;
      ActualNode := PredNode.ReadSucc;
      Inc(Index);
   end
end;

function  TLinList.GetElement: TObject;
begin
    result := ActualNode.readValue
 end;

function TLinList.GetIndex: Integer;
   begin
       GetIndex := Index
   end ;

function TLinList.isempty: Boolean;
  begin
      isempty := actualNode=nil
  end;

function TLinList.islast: boolean;
  begin
     islast:= isempty or (ActualNode.ReadSucc=nil)
  end;

function TLinList.Getcount: integer;
  begin
     GetCount:= count
  end;

end.
