unit URangier;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,UStapel_LinListNode,UBasisobjekte, ExtCtrls;

type
  TForm1 = class(TForm)
    LBA: TListBox;
    LBB: TListBox;
    LBC: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    BtRangiere: TButton;
    EdAnzahl: TEdit;
    BtNeu: TButton;
    Label4: TLabel;
    EdWaggon: TEdit;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Image1: TImage;
    procedure zeigealles;
    procedure BtNeuClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Umrangieren(st_a,st_b,st_c:TStapel);
    procedure BtRangiereClick(Sender: TObject);
  private
    stapel_a,stapel_b,stapel_c:TStapel;
    procedure transport(st_von,st_nach:TStapel);
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

(**************** hilfsprocs ***************)

procedure leere (var st :TStapel);
begin
   while not st.isempty do begin
      st.top.free;
      st.pop
   end
end;

procedure zeige(st :TStapel; lb :TListbox);
var hilf :TStapel;
    zahl : String;
begin
   lb.clear;
   hilf := TStapel.create;
   while not st.isempty do begin
      zahl := TInteger(st.top).gettext;
      lb.items.add(zahl);
      hilf.push(st.top);
      st.pop
    end;
   while not hilf.isempty do begin
      st.push(hilf.top);
      hilf.pop
   end;
   hilf.free;
end;

procedure TForm1.zeigealles;
begin
  zeige(stapel_a, LBA);
  zeige(stapel_b, LBB);
  zeige(stapel_c, LBC);
  ShowMessagePos('Taste',self.left+EdWaggon.left,
  self.top+EdWaggon.top+150)
end;


procedure TForm1.BtNeuClick(Sender: TObject);
var i,anz : Integer;
    neu   :TInteger;
begin
  anz := StrToInt(EdAnzahl.text);
  leere(stapel_a);
  leere(stapel_b);
  leere(stapel_c);
  for i := 1 to anz do begin
     neu := TInteger.create(random(anz*2));
     stapel_a.push(neu);
  end;
  zeige(stapel_a, LBA);
  zeige(stapel_b, LBB);
  zeige(stapel_c, LBC);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   stapel_a := TStapel.create;
   stapel_b := TStapel.create;
   stapel_c := TStapel.create;
end;

procedure TForm1.umrangieren(st_a,st_b,st_c:TStapel);
var hilf :TInteger ;
begin
     while not st_a.isempty do
        if st_c.isempty then
           transport(st_a,st_c)
        else  (*Zielst c nicht leer*)
           if TInteger(st_a.top).getvalue > TInteger(st_c.top).getvalue then
              while not st_c.isempty and
                   (TInteger(st_c.top).getvalue < TInteger(st_a.top).getvalue) do
                 transport(st_c,st_b)
           else
              transport(st_a,st_c);
  if not st_b.isempty then
    begin
     ShowMessagePos('Rekursiver Prozeduraufruf',
                    self.left+LBB.left,self.top+EdWaggon.top+150);
     umrangieren (st_b,st_a,st_c)
    end
  else
     ShowMessagePos('>>>>>>>>  F E R T I G <<<<<<<<',
         self.left+LBA.left,self.top+EdWaggon.top+150)
end;

procedure TForm1.transport(st_von,st_nach:TStapel);
var waggon:TInteger;
begin
   waggon:=TInteger(st_von.top);
   EdWaggon.text:=IntToStr(waggon.getvalue);
   st_von.pop;
   zeigealles;
   EdWaggon.text:='';
   st_nach.push(waggon);
   zeigealles
end;

procedure TForm1.BtRangiereClick(Sender: TObject);
begin
  umrangieren(stapel_a,stapel_b,stapel_c);
end;

end.
